#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "global.h"
#include "strutture.h"
#include "lettere.h"

int init_str();
int init_var();

int preproc(int a, char b[], char *c, int d[]);
int in_segm_out(char b[], char *c, int d[],FILE *fs, FILE *fd);

char sillabato[MAXLETTERE];
char *sillabe;
int  curr_pos;
char gruppo_vocalico[GV];
char *pt_gv;
int  curr_gv;
char lettera_acc[LA];
char *pt_la;
int  curr_la;

struct vocali   vv={"aeiou",5 };
struct consonanti cc={"bcdfghlmnpqrstvz",17};

struct bivocdiv bvdiv;
struct bivocin  bvin;
struct trivoc   vvv;

main(int argc, char *argv[])
{

char stringa[MAXLETTERE];
char *parola;
char *files;
char *filed;
char *modes="r";
char *moded="w+";

int c;
int lungh;
int accento[2];
int i;
int caso;

FILE *fs;
FILE *fd;

/* inizia codice */

 init_str();
 init_var();

 caso=argc;
 
 switch (caso)
 {
  case 1:
    fs=stdin;
    fd=stdout;
    break;
  case 2:
    files=*(++argv);
    fs=fopen(files,modes);
    fd=stdout;
    break;
  case 3:
    files=*(++argv);
    filed=*(++argv); 
    fs=fopen(files,modes);
    fd=fopen(filed,moded);
    break;
 }
 
 i=0;
 while ((c=getc(fs)) != EOF)
  {
   if ( c == ' ' ||  c == '\n'  || c == '\t' )
    {
     stringa[i]='\0';
     parola=stringa;
     lungh=strlen(parola);
     if(lungh > 0)
     {
      lungh=preproc(lungh, stringa, parola, accento);
      in_segm_out(stringa,parola, accento, fs, fd);     
     }
     i=0;
     parola=NULL;
    }
   else
    {
     stringa[i++]=(char)c;    
    } 
  }
}
