#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "strutture.h"
#include "global.h"


segment(int lun, char stringa[], char *parola, int caso, FILE *fd)
{
  int isin(char target);               /* match di carattere */
  int output(char a[MAXLETTERE], int b, FILE *c); /* emette parola sillabata*/
  int coda(int d, char e[MAXLETTERE]); /*copia ultima 
                                        sillaba in parola sillabata */
  int inner(int f, int g, char h[MAXLETTERE],char *i); /* aggiorna parola 
                                        sillabata con sillaba corrente*/
  int eccezione1(char l[MAXLETTERE], int m, int n); /* valuta eccezioni */
  int eccezione2(char l[MAXLETTERE], int m, int n); /* valuta eccezioni */
  int stripchar(int o, int p, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato carattere singolo */
  int stripvoc(int o, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato vocale singola e mette - */
  int matchbivoc(char *i);  /* controlla di 
                                        che tipo sono due vocali consecutive */

  extern char sillabato[MAXLETTERE];
  extern char *sillabe;
  extern int curr_pos;

  int esito;
  int esci;
  int bak_len;  /*contiene lunghezza di potenziale sillaba            */
  int depth;    /*cursor su parola da sillabare, ogni chiamata va a 0 */
  int mask;     /*maschera di navigazione su albero delle scelte      */
 
  char *bvv;
  char vett[3];

  char lettera;
  char hyphen='-';
  char close='\0';

/*
  fprintf(stdout,"stringa_in_segm= %s\n", stringa);
  fprintf(stdout,"parola_in_segm= %s\n", parola);
  fprintf(stdout,"sillabato_in_segm= %s\n", sillabato);
  fprintf(stdout,"depth_in_segm= %d\n", depth);
*/
  esci=NO;
  mask=1;
  depth=0;
  bvv=vett; /* inizializzo il puntatore */

  lettera=stringa[depth];
  do
  {
   esito=isin(lettera);
   switch (esito) /* esito=1 se consonante, 0 se vocale */
   {
     case 1:
      mask=(mask<<1)+1;
      break;
     case 0: 
      mask=(mask<<1);
      break;
     default:
      fprintf(stderr,"carattere sconosciuto: %c\n",lettera);
      return ERROR;
   }
   fprintf(stdout,"mask= %d\n", mask);
   switch (mask)
     {
      case 2: /* V */
            if(lun==1) /* caso vocale isolata */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 5: /* VC */
            bak_len=depth+1;
            if(lun==2) /* caso VC  isolate */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 6: /* CV */
            bak_len=depth+1;
            if(lun==2) /* caso CV isolate */
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;             

      case 7: /* CC */
            lun=stripchar(lun,depth,stringa,parola);
            esci=SI;
            break;         
 
      case 10: /* VCV  */
            if(lun==3)
            {
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            break;         

      case 11: /* VCC  */
            bak_len=depth+1;
            if(lun==3)
            {
             lun=coda(lun,stringa);
             esci=SI;
            }
            break;         

      case 12: /* CVV */
            if((stringa[0]=='q')||(stringa[0]=='Q'))
            {
             lun=stripchar(lun,1,stringa,parola);
             lun=stripchar(lun,1,stringa,parola);
             esci=SI;
            }
            else
            {
             strncpy(bvv,++parola,2);
             *(bvv+2)='\0';
             parola--;
             esito=matchbivoc(bvv); /* esito=1 da separare,
                                       esito=2 dittongo, non ancora decidibile 
                                       esito=ERROR  errore nella ricerca
                                     */
             if(esito==1)
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
             if(esito==2)
              {
               if(lun==3) /* caso  CV  da solo o a fine parola */ 
               {
                lun=coda(lun,stringa);
                esci=SI;
               }
              }
             if(esito==ERROR) 
              {
               fprintf(stderr,"Combinazione vocalica sconosciuta!!\n");
               return ERROR;   
              } 
            }
            break;
 
      case 13: /* CVC */
            if(lun==3)
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;
 
      case 20: /* VCVV  */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 21: /* VCVC  */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 22: /* VCCV */
            fprintf(stdout,"VCCV\n");
            bak_len--;
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            bak_len=eccezione2(stringa,bak_len,depth);
            fprintf(stdout,"bak_len=%d\n",bak_len);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 24: /* CVVV da fare*/
            break;
   
      case 25: /* CVVC */
            fprintf(stdout,"CVVC\n");
            bak_len=depth;
            break;

      case 26: /* CVCV */
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
  
      case 27: /* CVCC */
            bak_len=depth;
            break;
   
      case 46: /* VCCCV */
            fprintf(stdout,"VCCCV\n");
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            lun=inner(lun,bak_len-1,stringa,parola);
            esci=SI;
            break;

      case 47: /* VCCCC */
            fprintf(stdout,"VCCCC\n");
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 50:
            fprintf(stdout,"CVVCV\n");
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 51:
            fprintf(stdout,"CVVCC\n");
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case 54: /* CVCCV */
            fprintf(stdout,"CVCCV\n");
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            bak_len=eccezione1(stringa,bak_len,depth);
            fprintf(stdout,"bak_len=%d\n",bak_len);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
   
      case 55: /* CVCCC */
            bak_len=depth;
            break;

      case 110: /* CVCCCV */
            fprintf(stdout,"CVCCCV\n");
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            lun=inner(lun,bak_len-1,stringa,parola);
            esci=SI;
            break;

      case 111: /* CVCCCC */
            fprintf(stdout,"CVCCCC\n");
            fprintf(stdout,"bak_len=%d\n",bak_len);
            fprintf(stdout,"depth=%d\n",depth);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
 
      default:
            bak_len=depth;
            break;
     }
   depth++;
   lettera=stringa[depth];

  } while (esci==NO);

  if(lun>0)
    segment(lun,stringa,parola,caso,fd);
  else
    output(sillabato,caso,fd);
  return 0;
}
