#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "strutture.h"
#include "global.h"

segment(int lun, char stringa[], char *parola)
{
  int isin(char target);               /* match di carattere */
  int output(char a[MAXLETTERE], FILE *c); /* emette parola sillabata*/
  int coda(int d, char e[MAXLETTERE]); /*copia ultima 
                                        sillaba in parola sillabata */
  int inner(int f, int g, char h[MAXLETTERE],char *i); /* aggiorna parola 
                                        sillabata con sillaba corrente*/
  int eccezione1(char l[MAXLETTERE], int m, int n); /* valuta eccezioni */
  int stripchar(int o, int p, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato carattere singolo */
  int stripvoc(int o, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato vocale singola e mette - */
  int matchbivoc(char *i);  /* controlla di 
                                        che tipo sono due vocali consecutive */
  int matchtrivoc(int o, char *i); /* controlla di 
                                        che tipo sono tre vocali consecutive */

  int save_char(char q);     /* salva  un carattere in sillabato */

  extern char sillabato[MAXLETTERE];
  extern char *sillabe;
  extern int curr_pos;


  int esito;
  int match_esito;
  int esci;
  int bak_len;     /* contiene lunghezza di potenziale sillaba            */
  int depth;       /* cursor su parola da sillabare, ogni chiamata va a 0 */
  int local_pt;

  int mask;        /* maschera di navigazione su albero delle scelte      */
  int mask1;
  int posizione;

  int salva;       /* dice se salvare  vocale o no                        */
  int len;         /* variabile interna per usi locali                    */
  char lettera;
  char close='\0';

  char *bvv;       /* strutture per la gestione dei gruppi vocalici       */
  char vocali[4];

/* inizializzazioni locali                                                */


  esci=NO;
  mask=1;           /* nessuna decisione                                  */
  mask1=1;
  posizione=0;      /* nessun accento                                     */

  depth=0;          /* a inizio "parola"                                  */
  bvv=vocali;       /* inizializzo puntatore                              */

/* codice                                                                 */

  lettera=stringa[depth];
  do
  {
   esito=isin(lettera);
   switch (esito) 
   {
     case 0: /* vocale */
      mask=(mask<<1);
      break;

     case 1:  /* consonante */
      mask=(mask<<1)+1;
      break;

     case 2:  /* accentazione */
      posizione=256<<depth;
      break;

     default:
      if (lettera!='\0')
       {
        fprintf(stderr,"carattere sconosciuto: %c\n",lettera);
        return ERROR; 
       }
      break;
   }
 
   mask1=mask-posizione;

   fprintf(stdout,"mask1= %d\n", mask1);

   switch (mask1)
     {
      case 2: /* V */
            if(lun==1) /* caso vocale isolata */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 3: /* C */
            if(lun==1) /* caso consonante isolata */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case -510: /* V' */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_V'=%d\n",bak_len);
            if(lun==2) /* caso V'  isolata */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case -509: /* C' */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_C'=%d\n",bak_len);
            if(lun==2)
             { 
              lun=coda(lun,stringa);
              esci=SI;
             }
            break;

      case 4: /* VV */
            esito=isin(stringa[2]);
            if (esito==2)
               break;
            strncpy(bvv,parola,BIS);
            *(bvv+BIS)='\0';
            match_esito=matchbivoc(bvv);
            if (match_esito==1) /* vocali da separare */
              {
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* vocali da tenere insieme */
              {
               bak_len=depth+1;
               fprintf(stdout,"bak_len_in_VV=%d\n",bak_len);
               if(lun==2)
                {
                 lun=coda(lun,stringa);
                 esci=SI;
                }
              }
            fprintf(stdout,"sillabato_dopo_VV=%s\n",sillabato);
            break;

      case -1020: /* VV' */
            strncpy(bvv,parola,TRIS);
            *(bvv+TRIS)='\0';
            fprintf(stdout,"bvv_VV'=%s\n",bvv);
            match_esito=matchbivoc(bvv);
            fprintf(stdout,"match_esito_in_VV'=%d\n",match_esito);
            fprintf(stdout,"sillabato_VV'=%s\n",sillabato);
            if (match_esito==1) /* vocali da separare */
              {
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* vocali da tenere insieme */
              {
               bak_len=depth+1;
               fprintf(stdout,"bak_len_in_VV'=%d\n",bak_len);
              }
            fprintf(stdout,"sillabato_dopo_VV'=%s\n",sillabato);
            break;

      case -508: /* V'V */
            strncpy(bvv,parola,TRIS);
            *(bvv+TRIS)='\0';
            fprintf(stdout,"bvv_V'V=%s\n",bvv);
            match_esito=matchbivoc(bvv);
            fprintf(stdout,"match_esito_in_V'V=%d\n",match_esito);
            fprintf(stdout,"sillabato_V'V=%s\n",sillabato);
            if (match_esito==1) /* vocali da separare */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* vocali da tenere insieme */
              {
               bak_len=depth+1;
               fprintf(stdout,"bak_len_in_V'V=%d\n",bak_len);
              }
            fprintf(stdout,"sillabato_dopo_V'V=%s\n",sillabato);
            break;

      case 5: /* VC */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_VC=%d\n",bak_len);
            if(lun==2) /* caso VC  isolate */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 6: /* CV */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_CV=%d\n",bak_len);
            if(lun==2) /* caso CV isolate */
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;             

      case -507: /* V'C */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_V'C=%d\n",bak_len);
            if(lun==3) /* caso V'C  isolate */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case -506: /* C'V */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;

      case -1018: /* CV' */
            bak_len=depth+1;
            fprintf(stdout,"bak_len_in_CV'=%d\n",bak_len);
            if(lun==3) /* caso CV' isolate */
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;             

      case 7: /* CC */
            fprintf(stdout,"stringa=%s\n",stringa);
            fprintf(stdout,"lun,depth=%d %d\n",lun, depth);
            lun=stripchar(lun,depth,stringa,parola);
            esci=SI;
            break;         

      case 8: /* VVV  */
            esito=isin(stringa[3]);
            if (esito==2)
               break;
            strncpy(bvv,parola,TRIS);
            *(bvv+TRIS)='\0';
            match_esito=matchtrivoc(mask1,bvv);
            if (match_esito==1) /* V-VV */
              {
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* VV-V */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==3) /* VVV => V&VV+altro*/
              {
               lun=stripchar(lun,1,stringa,parola);
               esci=SI;
              }
            break;

      case -504: /* V'VV @@ */
            strncpy(bvv,parola,QUATTRO);
            *(bvv+QUATTRO)='\0';
            match_esito=matchtrivoc(mask1,bvv);
            fprintf(stdout,"match_esito_V'VV=%d\n",match_esito);
            if (match_esito==1) /* V'-VV */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* V'V-V */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==3) /* VVV => V'&VV+altro*/
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripchar(lun,1,stringa,parola);
               esci=SI;
              }
            break;

      case -1016: /* VV'V  @@ */
            strncpy(bvv,parola,QUATTRO);
            *(bvv+QUATTRO)='\0';
            match_esito=matchtrivoc(mask1,bvv);
            fprintf(stdout,"match_esito_VV'V=%d\n",match_esito);
            if (match_esito==1) /* V-V'V */
              {
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* VV'-V */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==3) /* VVV => V&V'V+altro */
              {
               lun=stripchar(lun,1,stringa,parola);
               esci=SI;
              }
            break;

      case -2040: /* VVV'  @@ */
            strncpy(bvv,parola,QUATTRO);
            *(bvv+QUATTRO)='\0';
            match_esito=matchtrivoc(mask1,bvv);
            fprintf(stdout,"match_esito_VVV'=%d\n",match_esito);
            if (match_esito==1) /* V-VV' */
              {
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==2) /* VV-V' */
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if (match_esito==3) /* VVV' => V&VV'+altro */
              {
               lun=stripchar(lun,1,stringa,parola);
               esci=SI;
              }
            break;

      case 9: case -1015:/* VVC o VV'C  */
            if(match_esito==2) /* vocali da tenere insieme */
             {
              lun=stripchar(lun,1,stringa,parola);
              esci=SI;
             }
            break;          

      case -503: /* V'VC */
            if(match_esito==2) /* vocali da tenere insieme */
             {
              lun=stripchar(lun,1,stringa,parola);
              lun=stripchar(lun,1,stringa,parola);
              esci=SI;
             }
            break;          

      case 10: /* VCV  */
            if(lun==3)
            {
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            break;         

      case  -502: /* V'CV */
            if(lun==4)
            {
             lun=stripchar(lun,1,stringa,parola);
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            break;         

      case  -2038: /* VCV' */
            if(lun==4)
            {
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            break;         

      case 11: /* VCC  */
            if (stringa[1] == stringa[2])
            {
             lun=stripchar(lun,1,stringa,parola);
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            bak_len=depth+1;
            if(lun==3)
            {
             lun=coda(lun,stringa);
             esci=SI;
            }
            break;         

      case -501: /* V'CC  */
            bak_len=depth+1;
            if(lun==4)
            {
             lun=coda(lun,stringa);
             esci=SI;
            }
            break;         

      case 12: case -1012: case -2036: /* CVV o CV'V o CVV' */
            lun=stripchar(lun,1,stringa,parola);
            fprintf(stdout,"lun1012=%d\n",lun);
            fprintf(stdout,"sillabato1012=%s\n",sillabato);
            esci=SI;
            break;
 
      case 13: /* CVC */
            if(lun==3)
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;

      case -1011: /* CV'C */
            if(lun==4)
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;

      case 18: case  -4078: /* VVCV o VVCV' con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;

      case -494: case  -1006: /* V'VCV o VV'CV con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;

      case 19: case  -1005: /* VVCC o VV'CC con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case  -493: /* V'VCC con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case 20: case -2028: case -4076: /* VCVV o VCV'V o VCVV' */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case -492: /* V'CVV  */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 21: case -2027: /* VCVC o VCV'C  */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case -491: /* V'CVC  */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 22: case -490: case -4074: /* VCCV o V'CCV o VCCV' */
            bak_len=2;
            bak_len=eccezione1(stringa,bak_len,depth);
            fprintf(stdout,"bak_len_in_segment22=%d\n",bak_len);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 23: case -489: /* VCCC o V'CCC */
            fprintf(stdout,"bak_len_in_segment23=%d\n",bak_len);
            fprintf(stdout,"carattere_corrente=%c\n",stringa[bak_len]);
            bak_len=eccezione1(stringa,bak_len,depth);
            fprintf(stdout,"bak_len_in_segment23_dopo=%d\n",bak_len);
            break;
            
      case 24: case -1000: case -2024: case -4072: /* CVVV con una delle V accentata*/
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            return ERROR;
   
      case 25: case -999: case -2023: /* CVVC con una delle V accentata*/
            bak_len=depth;
            break;

      case 26: case -998: case -2022: /* CVCV o CV'CV o CVCV' */
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
  
      case 27: case -997: /* CVCC o CV'CC */
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;
   
      case 46: case -466: case -8146: /* VCCCV o V'CCCV o VCCCV' */
	    fprintf(stdout,"stringa=%s\n",stringa);
	    fprintf(stdout,"stringa(1)=%c\n",stringa[1]);
	    if (stringa[1]=='s')
	      lun=inner(lun,bak_len-1,stringa,parola);	
	    else
              lun=inner(lun,bak_len,stringa,parola);
            fprintf(stdout,"sillabato_dopo_46=%s\n",sillabato);
            esci=SI;
            break;

      case 47: case -465: /* VCCCC o V'CCCC */
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 50: case -974: case -1998: case -8142: /*CVVCV,CV'VCV,CVV'CV,CVVCV'*/
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 51: case -1997: /* CVVCC o CVV'CC */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case -973: /* CV'VCC */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case 54: case -970: case -8138: /* CVCCV o CV'CCV o CVCCV' */
            bak_len=eccezione1(stringa,bak_len,depth);
            fprintf(stdout,"bak_len_in_segment54=%d\n",bak_len);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
   
      case 55: case -969: /* CVCCC o CV'CCC */
            bak_len=depth;
            break;

      case 110: case -914: case -16274:/* CVCCCV o CV'CCCV o CVCCCV' */
            lun=inner(lun,bak_len-1,stringa,parola);
            esci=SI;
            break;

      case 111: case -913: /* CVCCCC o CV'CCCC*/
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
 
      default:
            bak_len=depth;
            break;
     }
   depth++;
   lettera=stringa[depth];

  } while (esci==NO);

  if(lun>0)
    segment(lun,stringa,parola);
  else
    return 0;
}
